﻿using Microsoft.SharePoint.Client.Services;
using System.ServiceModel.Activation;
using System.Data.Services;
using System.Data.EntityClient;

namespace SPGSvcWp
{
    [BasicHttpBindingServiceMetadataExchangeEndpoint]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Required)]
    public class SPGDataService : DataService<Entities>
    {
        // This method is called only once to initialize service-wide policies.
        public static void InitializeService(IDataServiceConfiguration config)
        {
            //set access permissions on entities
            //TODO: modify sql user account to allow update
            config.SetEntitySetAccessRule("Products", EntitySetRights.All);
            config.SetEntitySetAccessRule("Customers", EntitySetRights.AllRead);

            // check:
            // http://spg-dev-jl/_vti_bin/SPGSvcWp/SPGDataService.svc/
        }

        protected override Entities CreateDataSource()
        {
            // override datasource since we don't use a config file

            string connectionString = string.Format("Data Source=.;Initial Catalog=Northwind;Persist Security Info=True;User ID=sa;Password=pass@word1;MultipleActiveResultSets=True");
            var builder = new EntityConnectionStringBuilder(@"metadata=res://*/NW.csdl|res://*/NW.ssdl|res://*/NW.msl;");
            builder.Provider = "System.Data.SqlClient";
            builder.ProviderConnectionString = connectionString;
            EntityConnection connection = new EntityConnection(builder.ConnectionString);
            return new Entities(connection);
        }


    }
}
